/*-------------------------------------------
@TCDLL.H
@KAZUBON 1997-1998
---------------------------------------------*/

#define _WIN32_IE 0x0300

#include <windows.h>
#include <windowsx.h>
#include <winreg.h>
#include <shellapi.h>
#include <winnls.h>
#include <commctrl.h>

#define CLOCKM_REFRESHCLOCK   (WM_USER+1)
#define CLOCKM_REFRESHTASKBAR (WM_USER+2)
#define CLOCKM_BLINK          (WM_USER+3)
#define CLOCKM_COPY           (WM_USER+4)

// tclock.c
void DrawClock(HWND hwnd, HDC hdc);
void FillClock(HWND hwnd, HDC hdc, RECT *prc, int nblink);
extern BOOL bNoClock;

// UTL.C
int _strncmp(const char* d, const char* s, size_t n);
HFONT CreateMyFont(char* fontname, int fontsize,
	LONG weight, LONG italic);
int ext_cmp(char *fname, char *ext);
void add_title(char *path, char *title);
void del_title(char *path);
void parse(char *dst, char *src, int n);
char* MyString(UINT id);
int GetMyRegStr(char* section, char* entry, char* val, int cbData, 
	char* defval);
LONG GetMyRegLong(char* section, char* entry, LONG defval);
LONG GetRegLong(HKEY rootkey, char*subkey, char* entry, LONG defval);
int GetRegStr(HKEY rootkey, char*subkey, char* entry,
	char* val, int cbData, char* defval);
BOOL SetMyRegStr(char* subkey, char* entry, char* val);
BOOL SetMyRegLong(char* subkey, char* entry, DWORD val);
void WriteDebug(LPSTR s);

// FORMAT.C
void InitFormat(SYSTEMTIME* lt);
void MakeFormat(char* s, SYSTEMTIME* pt, int beat100, char* fmt);
BOOL IsDispSecond(char* fmt);
BOOL IsDispSysInfo(char* fmt);
int IsDispBeat(char* fmt);
BOOL FindFormatStr(const char* fmt, const char *tofind);

// STARTBTN.C
void SetStartButton(HWND hwnd);
void EndStartButton(void);
void SetStartButtonBmp(void);
void CheckCursorOnStartButton(void);

// STARTMENU.C
void SetStartMenu(HWND hwnd);
void EndStartMenu(void);
void InitStartMenuIE4(void);
void ClearStartMenuIE4(void);

// taskswitch.c
void InitTaskSwitch(HWND hwndClock);
void EndTaskSwitch(void);

// traynotifywnd.c
void InitTrayNotify(HWND hwnd);
void EndTrayNotify(void);

// BMP.C
HBITMAP ReadBitmap(HWND hwnd, char* fname, BOOL b);

// newapi.c
void EndNewAPI(HWND hwnd);
void SetLayeredTaskbar(HWND hwnd);
void GradientFillClock(HDC hdc, RECT* prc, COLORREF col1, COLORREF col2);

// sysres.c
int GetFreeSystemResources(WORD wSysRes);
void EndSysres(void);

void InitBatteryLife(void);
int GetBatteryLifePercent(void);
void FreeBatteryLife(void);
